Swfdec Flash player

I compiled Swfdec version 0.8.4 and Swfdec-mozilla 0.8.2. The latter is a Flash plugin for Mozilla-based browsers.

It plays most of the videos at youtube, except for one small problem -- no sound. Running SeaMonkey from a terminal, I get this error message:

SWFDEC: ERROR: swfdec_audio_decoder.c(232): swfdec_audio_decoder_errorv: error decoding audio: no suitable decoder for audio codec 10

I have done a quick google and this error is reported many times. Have not yet seen a solution, will investigate some more.


Posted on 29 Dec 2009, 18:08


Comments:

Posted on 29 Dec 2009, 20:03 by BarryK
Swfdec working
I came across a report from someone that he rolled back to Swfdec 0.6.8 as that is the latest version that works. I need to find that URL again, but anyway, I gave it a go, and yippee, I get both video and sound at youtube.com.

I have compiled Swfdec against Gstreamer, though Swfdec can theoretically be compiled against ffmpeg (and not require Gstreamer) -- but I got compile errors.

Swfdec from 0.7.2 can no longer be compiled against ffmpeg, only Gstreamer.

Ah, here is a patch for Swfdec 0.6.8 to compile against ffmpeg 0.4.9:
http://forums.gentoo.org/viewtopic-t-702451-highlight-swfdec.html?sid=be46d27699d2c8e43d6d948494182093
...I might check that one out, though my ffmpeg in Quirky is a later version.



Posted on 29 Dec 2009, 21:17 by BarryK
Swfdec working with ffmpeg
I have compiled Swfdec 0.6.8 with ffmpeg (version in Quirky) and it works. I get both video and sound at youtube.com.

Now I need to create PET packages for Swfdec, Swfdec-mozilla and its dependencies, find out how the size compares with the Adobe Flash player.



Posted on 30 Dec 2009, 3:21 by technosaurus
gnash
Great news on Swfdec

gnash has quite a few extra options to compile against compared to swfdec, but you will probably need at least SDL (fairly small and would open up a lot of programs especially games)

... however the gstreamer option would open up a lot of other extras such as better html5 support and the potential to eventually create a better media player using vala's gstreamer bindings (using Totem etc... in the mean time)

...gstreamer is becoming harder and harder to avoid. I have great respect for Fabrice Bellard and ffmpeg, but gstreamer is just easier for the masses to program with.


Posted on 30 Dec 2009, 6:03 by panzerpuppy
YouTube videos with Open Source Flash !
Great job, BarryK!

Now where are those lovely .PET packages of Swfdec and Gnash for SeaMonkey ? :)



Posted on 30 Dec 2009, 8:58 by BarryK
Smaller Swfdec
Swfdec compiled against ffmpeg still requires extra pkgs:

liboil
libsoup
libgpg-error
libgcrypt
gnutls


The PET packages swfdec, swfdec-mozilla and those deps total 1421KB.

Hmmm, the Adobe Flash9 player PET is 2545KB, the Flash10 PET is 3951KB.

I thought that I would try an experiment. I compiled libsoup without SSL support, and as a static library only. I then compiled swfdec.

I then end up with swfdec that only needs liboil. The PET sizes are now:

swfdec-mozilla 23KB
swfdec 463KB
liboil 145KB

Which is a grand total of 631KB! Not too bad for a Flash player!

A disadvantage is that it won't play videos on https sites, and perhaps some newer format Flash videos -- that is something we need to experiment with, and I'm wondering if that situation would be improved if I recompiled ffmpeg with some extra codecs support.

A very useful thing about the Flash player plugin -- the right-click menu offers to download any videos on the site.

This is very interesting and highly appropriate for Quirky, which is aiming at the smallest possible size. I'll build 003 and upload soon, so anyone interested in playing with this Flash player and discovering its limitations, can do so. For example, I think that I read it is a CPU hog, but I haven't looked into that.



Posted on 30 Dec 2009, 12:03 by x
some progress that realy maters
thought was on the wrong site:)


Posted on 30 Dec 2009, 16:48 by ttuuxxx
opensourced flash
Hi Barry that is great news actually Gnutls is a better replacement for Openssl for sometime now, I found a great chart comparison, your last openssl package for 4 series in the repo was 716kb, so also you might want to consider that also on the flash 9,10 side, http://www.gnu.org/software/gnutls/comparison.html is the chart.
ttuuxxx


Posted on 30 Dec 2009, 23:45 by technosaurus
libsoup & webkit
You may want to keep the shared libsoup build in case you want to try out Midori, Chrome, or another WebkitGTK based browser in the future. Right now webkit depends on libICU as well, which makes it out of the realm of quirky unless you compile against ICU statically (shared lib is ~16Mb)... fortunately there are a couple of patches in the works to utilize glib only instead of ICU for unicode support.

Here is static Boost if you want to try Gnash without wasting a day compiling it.
http://puppy-development.googlecode.com/files/boost_DEV-1.40.0-i486.pet